package com.jiuqi.util.patterns;

import com.jiuqi.util.StringUtils;
import java.util.Map;

class VariablePattern implements IPattern {
   private String name;
   private int length;

   public void parse(String expression) throws PatternException {
      this.clear();
      if (expression != null) {
         int p = expression.lastIndexOf(58);
         if (p == -1) {
            this.name = expression;
            this.length = 0;
         } else {
            this.name = expression.substring(0, p);
            String valStr = expression.substring(p + 1);
            if (StringUtils.isEmpty(valStr)) {
               this.length = 0;
            } else {
               try {
                  this.length = Integer.parseInt(valStr);
               } catch (NumberFormatException var5) {
                  NumberFormatException e = var5;
                  throw new PatternException(e);
               }
            }
         }

      }
   }

   public String toString() {
      StringBuffer buffer = new StringBuffer("${");
      if (this.length == 0) {
         buffer.append(this.name);
      } else {
         buffer.append(this.name).append(':').append(this.length);
      }

      buffer.append('}');
      return buffer.toString();
   }

   public void add(IPattern pattern) {
   }

   public void add(int index, IPattern pattern) {
   }

   public void clear() {
      this.name = null;
      this.length = 0;
   }

   public IPattern get(int index) {
      return null;
   }

   public String getExpression() {
      return this.name;
   }

   public int getLength() {
      return this.length;
   }

   public int getType() {
      return 1;
   }

   public int indexOf(IPattern pattern) {
      return -1;
   }

   public void remove(int index) {
   }

   public void setExpression(String value) {
      try {
         this.parse(value);
      } catch (PatternException var2) {
         this.clear();
      }

   }

   public void setLength(int value) {
      this.length = value;
   }

   public int size() {
      return 0;
   }

   public int match(String s, int start, Map values) {
      return this.length != 0 && start + this.length <= s.length() ? start + this.length : -1;
   }

   public String replace(ITranslator translator) {
      String[] ret = translator.translate(this.name, this.length);
      if (ret == null) {
         return this.toString();
      } else {
         return ret.length == 0 ? "" : ret[0];
      }
   }
}
